#include "Fixed.hpp"
#include <iostream>

int main( void ) {
	{
		Fixed a(0);
		Fixed const b( Fixed( 5.05f ) * Fixed( 2 ) );
		std::cout << a << std::endl;
		std::cout << ++a << std::endl;
		std::cout << a << std::endl;
		std::cout << a++ << std::endl;
		std::cout << a << std::endl;
		std::cout << b << std::endl;
		std::cout << Fixed::max( a, b ) << std::endl;
	}
   	{
    const Fixed a(2.5f);
    const Fixed b(1.3f);

    std::cout << "b: " << b << std::endl;
    std::cout << "a: " << a << std::endl;

    Fixed sum = a + b;
    std::cout << "Addition: " << sum << std::endl;
    
	Fixed difference = a - b;
    std::cout << "Subtraction: " << difference << std::endl;

    Fixed product = a * b;
    std::cout << "Multiplication: " << product << std::endl;

    Fixed quotient = a / b;
    std::cout << "Division: " << quotient << std::endl;

    bool isEqual = (a == b);
    std::cout << "Is a equal to b? " << std::boolalpha << isEqual << std::endl;

    bool isNotEqual = (a != b);
    std::cout << "Is a not equal to b? " << std::boolalpha << isNotEqual << std::endl;

    bool isLessThan = (a < b);
    std::cout << "Is a less than b? " << std::boolalpha << isLessThan << std::endl;

    bool isGreaterThan = (a > b);
    std::cout << "Is a greater than b? " << std::boolalpha << isGreaterThan << std::endl;

    bool isLessThanOrEqual = (a <= b);
    std::cout << "Is a less than or equal to b? " << std::boolalpha << isLessThanOrEqual << std::endl;

    bool isGreaterThanOrEqual = (a >= b);
    std::cout << "Is a greater than or equal to b? " << std::boolalpha << isGreaterThanOrEqual << std::endl;
	}
    return 0;
}
